# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section   free
%define base_name   torque

Name:           db-%{base_name}
Version:        3.2
Release:        1jpp
Epoch:          0
Summary:        Torque persistence layer

Group:          Development/Libraries/Java
License:        Apache Software License
URL:            http://db.apache.org/torque/
Source0:        http://www.apache.org/dyn/closer.cgi/db/torque/torque-3.2/source/torque-3.2-src.tar.gz
Source1:        http://www.apache.org/dyn/closer.cgi/db/torque/torque-3.2/source/torque-gen-3.2-src.tar.gz
Source2:        http://www.apache.org/dyn/closer.cgi/db/torque/torque-3.2/source/maven-torque-plugin-3.2-src.tar.gz
Source3:        torque-gen-templates-3.2-src.tar.gz
# svn export http://svn.apache.org/repos/asf/db/torque/templates/tags/TORQUE_3_2/

Source4:        pom-maven2jpp-depcat.xsl
Source5:        pom-maven2jpp-newdepmap.xsl
Source6:        pom-maven2jpp-mapdeps.xsl
Source7:        db-torque-3.2-jpp-depmap.xml

#Patch0:         torque-3.1-no-stratum.patch
#Patch1:         db-torque-maven-plugin-3.1.1-plugin_jelly.patch
#Patch2:		db-torque-3.1.1-project-base_xml.patch
#Patch3:		db-torque-3.1.1-generator-project_xml.patch
Patch0:		db-torque-3.2-torque-gen-templates-common-project_xml.patch
Patch1:		db-torque-3.2-torque-gen-common-project_xml.patch
Patch2:		db-torque-3.2-torque-common-project_xml.patch
Patch3:		db-torque-3.2-maven-torque-plugin-common-project_xml.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Distribution:   JPackage
Vendor:         JPackage Project

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  java-devel >= 0:1.4
BuildRequires:  junit
BuildRequires:  maven
BuildRequires:  avalon-framework
BuildRequires:  avalon-logkit
BuildRequires:  gnu.getopt
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-configuration >= 0:1.0.f
BuildRequires:  jakarta-commons-dbcp
BuildRequires:  jakarta-commons-lang
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-pool
BuildRequires:  jakarta-jcs
BuildRequires:  jdbc-stdext >= 0:2.0
BuildRequires:  jndi >= 0:1.2.1
BuildRequires:  log4j
BuildRequires:  village
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:  avalon-framework
Requires:  avalon-logkit
Requires:  jakarta-commons-beanutils
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-configuration >= 0:1.0.f
Requires:  jakarta-commons-dbcp
Requires:  jakarta-commons-lang
Requires:  jakarta-commons-logging
Requires:  jakarta-commons-pool
Requires:  jakarta-jcs
Requires:  jdbc-stdext >= 0:2.0
Requires:  jndi >= 0:1.2.1
Requires:  log4j
Requires:  village
Requires:  xerces-j2
Requires:  xml-commons-apis

%description
Torque is a persistence layer. Torque includes a 
generator to generate all the database resources 
required by your application and includes a 
runtime environment to run the generated classes. 

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Docs for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.

%package        gen
Summary:        Generator for %{name}
Group:          Development/Libraries/Java

%description    gen
%{summary}.

%package        gen-javadoc
Summary:        Javadoc for %{name}-gen
Group:          Development/Documentation

%description    gen-javadoc
%{summary}.

%package        gen-manual
Summary:        Docs for %{name}-gen
Group:          Development/Documentation

%description    gen-manual
%{summary}.

%package        maven-plugin
Summary:        Maven plugin for %{name}
Group:          Development/Libraries/Java

%description    maven-plugin
%{summary}.

%package        maven-plugin-manual
Summary:        Docs for %{name}-maven-plugin
Group:          Development/Documentation

%description    maven-plugin-manual
%{summary}.

%prep
%setup -T -c -n %{base_name}-%{version}
tar xzf %{SOURCE0}
tar xzf %{SOURCE1}
tar xzf %{SOURCE2}
tar xzf %{SOURCE3}

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav

%build
export DEPCAT=$(pwd)/db-torque-3.2-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE4} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE5} > db-torque-3.2-depmap.new.xml

for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE6} map=%{SOURCE7}
    popd
done

mkdir .maven
mkdir -p .maven/repository/JPP/jars
touch .maven/repository/JPP/jars/jdbc.jar
touch .maven/repository/JPP/jars/jndi.jar
#touch .maven/repository/JPP/jars/stratum.jar
##mkdir -p .maven/repository/maven/plugins
##pushd .maven/repository/maven/plugins
##ln -s $(build-classpath sf-maven-plugins/maven-findbugs-plugin) .
##popd

MAVEN_HOME_LOCAL=$(pwd)/.maven
pushd torque-gen-templates-3.2
maven \
        -Dmaven.repo.remote="file:/usr/share/maven/repository,file:/usr/share" \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc xdoc:transform
popd
pushd torque-gen-3.2
maven \
        -Dmaven.repo.remote="file:/usr/share/maven/repository,file:/usr/share" \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc xdoc:transform
popd
pushd torque-3.2
maven \
        -Dmaven.repo.remote="file:/usr/share/maven/repository,file:/usr/share" \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc xdoc:transform
popd
pushd maven-torque-plugin-3.2
maven \
        -Dmaven.repo.remote="file:/usr/share/maven/repository,file:/usr/share" \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc xdoc:transform
popd

%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 %{base_name}-%{version}/target/%{base_name}-%{version}.jar \
                  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 %{base_name}-gen-%{version}/target/%{base_name}-gen-%{version}.jar \
                  $RPM_BUILD_ROOT%{_javadir}/%{name}-gen-%{version}.jar
install -m 644 %{base_name}-gen-templates-%{version}/target/%{base_name}-gen-templates-%{version}.jar \
                  $RPM_BUILD_ROOT%{_javadir}/%{name}-gen-templates-%{version}.jar
# maven-plugin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins
install -m 644 maven-%{base_name}-plugin-%{version}/target/maven-%{base_name}-plugin-%{version}.jar \
$RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins/maven-%{base_name}-plugin-%{version}.jar

pushd $RPM_BUILD_ROOT%{_javadir}
ln -s %{name}-%{version}.jar %{name}.jar
ln -s %{name}-gen-%{version}.jar %{name}-gen.jar
ln -s %{name}-gen-templates-%{version}.jar %{name}-gen-templates.jar
popd
pushd $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins
ln -s maven-%{base_name}-plugin-%{version}.jar maven-%{base_name}-plugin.jar
popd

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
cp -pr torque-3.2/src/conf/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-gen-%{version}
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-gen-%{version}/conf
cp -pr torque-gen-3.2/src/conf/* $RPM_BUILD_ROOT%{_datadir}/%{name}-gen-%{version}/conf
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-gen-%{version}/dtd
cp -pr torque-gen-3.2/src/dtd/* $RPM_BUILD_ROOT%{_datadir}/%{name}-gen-%{version}/dtd
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-gen-%{version}/schema
cp -pr torque-gen-3.2/src/schema/* $RPM_BUILD_ROOT%{_datadir}/%{name}-gen-%{version}/schema

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr %{base_name}-%{version}/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf %{base_name}-%{version}/target/docs/apidocs

# manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr %{base_name}-%{version}/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 %{base_name}-%{version}/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


# generator javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen-%{version}
cp -pr %{base_name}-gen-%{version}/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen-%{version}
ln -s %{name}-gen-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen # ghost symlink
rm -rf %{base_name}-gen-%{version}/target/docs/apidocs

# generator manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-gen-%{version}
cp -pr %{base_name}-gen-%{version}/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-gen-%{version}
install -m 644 %{base_name}-gen-%{version}/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-gen-%{version}

# maven-plugin manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-maven-plugin-%{version}
cp -pr maven-%{base_name}-plugin-%{version}/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-maven-plugin-%{version}
install -m 644 maven-%{base_name}-plugin-%{version}/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-maven-plugin-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%post gen-javadoc
rm -f %{_javadocdir}/%{name}-gen
ln -s %{name}-gen-%{version} %{_javadocdir}/%{name}-gen

%postun gen-javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}-gen
fi

%files
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/%{name}-%{version}

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}

%files gen
%defattr(-,root,root,-)
%{_javadir}/%{name}-gen-templates-%{version}.jar
%{_javadir}/%{name}-gen-templates.jar
%{_javadir}/%{name}-gen-%{version}.jar
%{_javadir}/%{name}-gen.jar
%{_datadir}/%{name}-gen-%{version}
%doc %{_docdir}/%{name}-gen-%{version}/LICENSE.txt

%files gen-javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-gen-%{version}
%ghost %doc %{_javadocdir}/%{name}-gen

%files gen-manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-gen-%{version}

%files maven-plugin
%defattr(-,root,root,-)
%{_datadir}/maven/repository/JPP/plugins/maven-torque-plugin-%{version}.jar
%{_datadir}/maven/repository/JPP/plugins/maven-torque-plugin.jar
%doc %{_docdir}/%{name}-maven-plugin-%{version}/LICENSE.txt

%files maven-plugin-manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-maven-plugin-%{version}

%changelog
* Mon Feb 20 2006 Ralph Apel <r.apel at r-apel.de> - 0:3.2-1jpp
- Upgrade to 3.2
- maven-simian-reports patched out iot avoid simian BR

* Wed Feb 15 2006 Ralph Apel <r.apel at r-apel.de> - 0:3.1.1-4jpp
- Adapt to maven-1.1

* Tue Nov 01 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.1.1-3jpp
- Change requirement from jakarta-turbine-jcs to jakarta-jcs

* Sat Mar 05 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.1.1-2jpp
- Fix problem with maven.home.local

* Mon Feb 21 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.1.1-1jpp
- Upgrade to 3.1.1
- Build with maven

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:3.1-2jpp
- Build with ant-1.6.2
- Relax some versioned requirements

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:3.1-1jpp
- First JPackage release.
